# 1. Working Directory setzen
setwd("")

# R-Objekte

# Vektor

## Erstellung
v <- c(1,2,3,4,5,6) 
v
a <- c("a", "b", "c")
a

#Indizierung
v[3]
a[3]
v[2:4]
v[-3]
v[c(1,5)]

# Struktur
str(v)
str(a)

# Matrix

# Erstellung

m <- matrix(c(1,2,3,4,5,6), ncol=3, byrow=FALSE )
m

# Indizierung
m[1,]

# Erstellung
str(m)


# Listen
# Erstellung
l <- list(var1 = c(1,2,3),
          var2 = c("a","b", "c","d"),
          var3 = c("m","w","m", "m"))
l

#Indizierung
l[2]
l[[2]]
l[[2]][3]
l[[3]] <- as.factor(l[[3]])


# Struktur:
str(l)
class(l)

# Data-Frame

# Erstellung

Var1 <- c(1,2,3)
Var2 <- c("a","b", "c")
D<- data.frame(Var1, Var2)

# Indizierung
D[1,2]
D$Var1

# Struktur
str(D)

# Saubermachen
rm(D)

#######################################
########## Aufgaben R-Datensatz########
#######################################

# 1. Txt-Datensatz bei R einlesen
D <- read.delim("Daten.txt", header= TRUE, sep="\t")

summary(D)
summary(D$Age)
View(D)

# 2. Datensatz auf relevante Variablen reduzieren

D <- subset(D, select =c(Subject, 
                         Sex, 
                         Age, 
                         Procedure.Block., 
                         mensch_valenz.Block.,
                         Questions1.RESP,
                         Stim.RT,
                         Stim.ACC))
# 2b Variablen anstndig benennen

names(D)<- c("Subject", 
             "Sex", 
             "Age",
             "Proc",
             "M_val",
             "Mis",
             "Reactiontime",
             "ACC")

# Zwischenspeichern

save(D, file="Daten.RData")

# Laden: 

load(file="Daten.RData")


# 3. Flle nach Subject Variable sortieren

unique(D$Subject)

D <- D[order(D$Subject),]

unique(D$Subject)

# 4. bungstrials entfernen

unique(D$Proc)
#a) Reaktionszeitdaten (IAT)

D_a <- subset(D, Proc =="prcMain")

#b) Fragebogendaten

D_b <- subset(D, Proc =="Rating1")
  
D <- D_a
rm(D_a)

# Speichern

save(D, D_b, file="Daten.RData")

# 5. Numerische Variablen vom Geschlecht bilden

D$Geschlecht <- ifelse(D$Sex == "female",2,1)

table(D$Sex, D$Geschlecht)

# 6. Reaktionszeitvariable berechnen

D$RT <- D$Reactiontime

# 7. Reaktionszeit bei Fehler rauswerfen

D$RT <- ifelse(D$ACC !=1, NA, D$RT)

# 8. Fehlerzhlvariable bilden

D$Fehler <- ifelse(D$ACC ==1, 0, 1)


# 9. Fehler analysieren

Fehler <- as.data.frame(tapply(D$Fehler, D$Subject, sum))

names(Fehler) <- c("Summe")

summary(Fehler$Summe)

Fehler[(Fehler$Summe > 30),]

Fehler$Prozent <- (Fehler$Summe/193)

# 10. Probanden rausnehmen

# Nr. 49

D <- subset(D, Subject != 49)
D_b <- subset(D_b, Subject != 49)

# Nr. 71

D <- subset(D, Subject != 71)
D_b <- subset(D_b, Subject != 71)

rm(Fehler)

# 11. Quartile ausgeben lassen

# Option 1
summary(D$RT)

# Option 2
boxplot(D$RT)

# Option 3

quantile(D$RT, c(.25,.50,.75), na.rm=TRUE)

# 12. Far-Outlier berechnen und rauswerfen

#a) Far-Outlier berechnen

644 - 447

644 + 3*197

# b) rauswerfen

D$RT <- ifelse(D$RT > 1235, NA, D$RT)

# 13. Neues Dataframe mit Quartilen pro Person

Dq <- tapply(D$RT, D$Subject, quantile, na.rm=TRUE) #Liste

Dq <- unlist(Dq) #Vektor

Dq <- matrix(Dq, ncol=5, byrow=TRUE) # Matrix

Dq <- as.data.frame(Dq) # Data-Frame

names(Dq) <- c("Perz0", "Perz25", "Perz50", "Perz75", "Perz100")

Dq <- Dq[,2:4]

Dq$Subject <- unique(D$Subject)

# Speichern

save(D, Dq, D_b, file="Daten.RData")

# Laden

load(file="Daten.RData")

